__author__ = "Your Name Goes Here"

def fly(from_, to, schedule):
    """fly("Dresden", "Cairo", ...) => ["Berlin", "Athens", "Athens", "Cairo"]
    
    Calculates the cheapest route starting with "from_" and arriving at "to"
    using the provided schedule.
    
    Input:

    The schedule is a list of dictionaries. Each dictionary contains the
    schedule for one day of flights. The list is ordered by day i.e. the
    first dictionary contains the schedule for day 1, the second for day 2,
    etc.
    
    The dictionaries represent a flight schedule as:
    (departure city, arrival city) : flight cost

    Rules:
    - Only one flight per day can be taken
    - Instead of taking a flight, it is possible to wait in the current city,
      which costs 20 EURO per day.
      
    Output:
    
    If now route to the destination is possible, ValueError is raised.
    
    If a route is possible, then it is returned as a list of the cities flown
    to. For each day spend in a city (instead of flying), that city name also
    appears in the list. e.g.
    => ['Berlin', # On day 1, a flight is taken to Berlin
     'Athens',    # On day 2, a flight is taken to Athens
     'Athens,     # On day 3, stay one day in Athens (cost 20 EURO)
     'Dresden]    # On day 4, a flight is taken to Dresden
    
    Example 1:
    >>> schedule = [
    ... # (from, to) : cost
    ... {('A', 'B') : 100.00, ('A', 'C') : 10.00, ('C', 'B') : 20}, # Day 1
    ... {('A', 'B') : 100.00, ('A', 'C') : 10.00, ('C', 'B') : 20}] # Day 2
    >>> # Calculate the optimal route to fly from A to B. The route should be:
    >>> # Day 1: A => C (cost 20) 
    >>> # Day 2: C => B (cost 20)
    >>> fly('A', 'B', schedule)
    ['C', 'B']
    
    Example 2:
    >>> schedule = [
    ...   # From    # To       # Cost
    ... {('Athens', 'Berlin') : 55.25,   # Day 1 flights
    ...  ('Berlin', 'Athens') : 73.00,   
    ...  ('Dresden', 'Athens') : 85.50,
    ...  ('Dresden', 'Berlin') : 12.50},
    ... {('Berlin', 'Athens') : 23.55,   # Day 2 flights
    ...  ('Berlin', 'Cairo') : 125.15,  
    ...  ('Berlin', 'Dresden') : 18.25,
    ...  ('Dresden', 'Athens') : 85.50,
    ...  ('Dresden', 'Berlin') : 13.50},
    ... {('Athens', 'Cairo') : 65.55,    # Day 3 flights
    ...  ('Berlin', 'Athens') : 23.55,
    ...  ('Berlin', 'Cairo') : 125.15,
    ...  ('Dresden', 'Athens') : 85.50},
    ... {('Athens', 'Cairo') : 7.25,     # Day 4 flights
    ...  ('Berlin', 'Athens') : 23.55,
    ...  ('Dresden', 'Athens') : 85.50}]

    >>> # Calculate the optimal route to fly from Dresden to Cairo.
    >>> # The route should be:
    >>> # Day 1: Dresden => Berlin (cost 12.50) 
    >>> # Day 2: Berlin => Athens (cost 23.55)
    >>> # Day 3: Athens (stay the day: cost of 20)
    >>> # Day 4: Athens => Cairo (cost  7.25)
    >>> # If you think that this route is absurd, let me assure
    >>> # you that I am actually flying it (including the night in
    >>> # Athens) in October
    >>> fly('Dresden', 'Cairo', schedule)
    ['Berlin', 'Athens', 'Athens', 'Cairo']
    >>> # There is now way to get from Cairo to Dresden
    >>> fly('Cairo', 'Dresden', schedule)
    Traceback (most recent call last):
    ...
    ValueError
    """
    
    raise NotImplementedError()

if __name__ == "__main__":
    import fly_test
    fly_test.main(['fly'])